Módulo 5 · 5.2
Exportar calendário e contactos do Google e do Microsoft
Módulo 5: Agenda e contactos · Tempo de leitura: 12 minutos
Objetivo de aprendizagem: Após esta lição, saberá fazer uma exportação completa e utilizável de calendários e contactos do Google e do Microsoft, ler um ficheiro ICS e vCard, e saberá o que não é transferido ou é transferido de forma diferente ao exportar.
Conceitos-chave: iCalendar (ICS), VCALENDAR, VEVENT, UID, DTSTART, RRULE, EXDATE, VTIMEZONE e TZID, ORGANIZER e ATTENDEE, VALARM, vCard (VCF) 3.0 e 4.0, csv, Google Takeout, ferramenta de migração
Dois formatos de ficheiro que quase toda a gente conhece
Transfere calendários e contactos com dois formatos abertos:
- iCalendar, ficheiros com a extensão
.ics(RFC 5545), para calendários e tarefas. - vCard, ficheiros com a extensão
.vcf, para contactos. Há duas versões que pode encontrar: 3.0 (RFC 2426) e 4.0 (RFC 6350).
São ficheiros de texto normais. Pode abri-los num editor de texto, e é exatamente isso que vai fazer nesta lição. Quem sabe o que está lá dentro, também vê o que falta.
Muitas vezes existe um caminho mais fácil do que exportar: muitos serviços novos têm uma ferramenta de migração que, com a sua autorização, vai diretamente buscar os seus calendários e contactos ao Google ou ao Microsoft. Isso é mais rápido e com menos erros. Mesmo assim, é aconselhável fazer a sua própria exportação: como verificação (quantos compromissos e contactos tinha?), como cópia de segurança antes de cancelar o serviço antigo, e como alternativa caso o administrador não permita a ferramenta de migração.
Assim é um ficheiro de calendário
Uma exportação do calendário da Bakkerij De Korrel começa assim:
BEGIN:VCALENDAR
VERSION:2.0
PRODID:-//Google Inc//Google Calendar 70.9054//EN
BEGIN:VTIMEZONE
TZID:Europe/Amsterdam
...
END:VTIMEZONE
BEGIN:VEVENT
UID:3f1a9c2e7b@google.com
DTSTART;TZID=Europe/Amsterdam:20261110T060000
DTEND;TZID=Europe/Amsterdam:20261110T070000
RRULE:FREQ=WEEKLY;BYDAY=TU
EXDATE;TZID=Europe/Amsterdam:20261229T060000
SUMMARY:Levering meel
ORGANIZER:mailto:anne@example.com
ATTENDEE;CN=Groothandel:mailto:verkoop@example.net
BEGIN:VALARM
TRIGGER:-PT30M
ACTION:DISPLAY
END:VALARM
END:VEVENT
END:VCALENDARO que se vê:
| Linha | Significado | Onde pode correr mal |
|---|---|---|
BEGIN:VCALENDAR e VERSION:2.0 | este é um ficheiro iCalendar | se faltar, a importação é recusada |
BEGIN:VEVENT ... END:VEVENT | um compromisso | um END em falta torna o resto ilegível |
UID | o identificador fixo do compromisso | sem UID, o servidor não consegue reconhecer duplicados |
DTSTART;TZID=... | hora de início num fuso horário | ver fusos horários abaixo |
RRULE | regra de repetição: todas as terças-feiras | uma regra inválida dá um único compromisso em vez de uma série |
EXDATE | exceção: nesta terça-feira em concreto não se realiza | |
ORGANIZER, ATTENDEE | quem convidou e quem foi convidado | ver convites abaixo |
VALARM | lembrete, 30 minutos antes | nem todos os serviços preservam os lembretes |
Fusos horários
Uma hora com TZID=Europe/Amsterdam significa: 6 horas da manhã em Amesterdão, mesmo depois da transição para a hora de verão. O ficheiro deve, por isso, conter um bloco VTIMEZONE que descreva esse fuso horário. As exportações do Outlook utilizam frequentemente nomes do Windows, como W. Europe Standard Time. Isso funciona bem desde que o bloco VTIMEZONE esteja incluído. Se faltar, o novo serviço tem de adivinhar, e verá os compromissos deslocados numa hora. Uma hora terminada em Z (20261110T050000Z) está em UTC e é sempre inequívoca. Uma hora sem fuso horário e sem Z chama-se hora "flutuante": aplica-se ao fuso horário de quem a visualiza.
Os compromissos de dia inteiro aparecem como data sem hora: DTSTART;VALUE=DATE:20261224.
Convites
Um compromisso que tenha organizado aparece com o seu nome como ORGANIZER no ficheiro. Depois da importação, fica na sua nova agenda, mas os participantes continuam a ter esse compromisso na sua própria agenda como um convite vindo do seu endereço antigo, com um UID do serviço antigo. Se alterar o compromisso mais tarde, recebem um novo convite. Em reuniões recorrentes com pessoas externas, pode ser mais apropriado voltar a convidá-las depois da mudança. Os compromissos para os quais foi convidado são transferidos como compromissos normais; as respostas ao organizador são feitas por correio eletrónico.
Exportar a partir do Google
- Calendário: no Google Agenda, em Definições, na secção Importar e exportar, o botão Exportar. Recebe um ficheiro zip com um ficheiro ics por cada calendário do qual é proprietário. Os calendários que outras pessoas partilham consigo não estão incluídos; estes são exportados pelo proprietário, ou pode exportá-los individualmente a partir das definições desse calendário, se tal for permitido.
- Contactos: no Google Contactos, seleciona os contactos (ou todos), escolhe Exportar e depois o formato vCard. O Google também oferece "Google CSV" e "Outlook CSV"; escolha vCard, que preserva a estrutura (vários números de telefone, moradas, fotografia).
- Tudo de uma vez: o Google Takeout (takeout.google.com) fornece o calendário em ics, os contactos em vcf (ou csv) e o Gmail em mbox, em ficheiros zip. Útil como cópia de segurança de toda a conta.
Os nomes dos menus mudam de vez em quando; em caso de dúvida, pesquise na ajuda do Google por "exportar calendário".
Exportar a partir do Microsoft
- Calendário: no Outlook clássico para Windows pode guardar um calendário como ficheiro iCalendar (Guardar como, com escolha do período e "detalhes completos"). Escolha um período que recue e avance o suficiente, e escolha detalhes completos, caso contrário só exporta livre/ocupado. No Outlook na Web pode publicar um calendário como ligação ICS e transferir o ficheiro através dessa ligação; depois desative novamente a publicação.
- Contactos: o Outlook na Web exporta os contactos como csv, não como vCard. O Outlook clássico também exporta em massa para csv; o vCard só é possível por contacto individual. Muitos serviços CardDAV não conseguem importar diretamente um ficheiro csv. Há duas alternativas: utilizar a ferramenta de migração do seu novo serviço (que vai buscar os contactos diretamente), ou importar o csv num livro de endereços do Thunderbird e exportá-lo a partir daí como vCard.
- Calendários partilhados e de recursos (salas) são calendários da organização. São exportados pelo administrador, ou são configurados novamente no novo serviço.
O que não é transferido, ou é transferido de forma diferente, ao exportar
| Elemento | O que acontece |
|---|---|
| Anexos dos compromissos | geralmente não são transferidos; apenas uma ligação, ou nada |
| Cores e categorias | por vezes como CATEGORIES, muitas vezes não |
| Lembretes | por vezes, dependendo do serviço |
| Ligações de videoconferência (Teams, Meet) | ficam como texto no compromisso, mas deixam de funcionar depois do cancelamento |
| Grupos de contactos ou etiquetas | nem sempre; verifique depois da importação |
| Fotografias de contactos | são transferidas no vCard, mas tornam o ficheiro volumoso |
Contar antes de avançar
Antes da exportação, anote quantos contactos tem e, para alguns calendários, quantos compromissos existem num período fixo (por exemplo, novembro). Depois da importação, conte novamente. É a forma mais rápida de perceber se falta alguma coisa. No exercício desta lição, deixa o programa contar e verificar os seus ficheiros.
Na prática: como é com um fornecedor
Num Nextcloud do WebOké existem duas ferramentas de migração que vão buscar os dados diretamente: a WebOké Import Tool para o Google (Drive, Fotografias, Agenda e Contactos) e Migração de Dados para o OneDrive e o Microsoft 365, com a qual também importa contactos e calendários da sua conta Microsoft. Se o seu calendário vier de outro sítio, importa os ficheiros ics e vCard você mesmo (lição 5.3). O Nextcloud lê vCard 3.0 e 4.0. Noutros serviços europeus existem ferramentas de importação semelhantes ou um botão de importação na agenda e no livro de endereços; os formatos de ficheiro são os mesmos em todo o lado.
Resumo
- Transfere os calendários como ics (iCalendar), os contactos como vcf (vCard 3.0 ou 4.0); são ficheiros de texto legíveis.
- Uma ferramenta de migração que vai buscar os dados diretamente costuma ser mais fácil, mas faça mesmo assim a sua própria exportação como verificação e cópia de segurança.
- Num ficheiro ics, preste atenção ao UID, à RRULE e aos fusos horários com um bloco VTIMEZONE; sem isso, os compromissos ficam deslocados.
- O Outlook na Web exporta os contactos apenas como csv; utilize uma ferramenta de migração ou converta o csv para vCard.
- Conte previamente os contactos e os compromissos, para poder verificar depois da importação se falta alguma coisa.
Quiz
Exercício
Exercício A5.2: Verificar a sua exportação de teste. Exporte um calendário (ics) e os seus contactos (vcf). Indique primeiro quantos contactos tem e quantos compromissos espera. Depois carregue os ficheiros. O programa verifica se são válidos, conta compromissos, repetições e contactos, procura fusos horários sem descrição e contactos duplicados, e compara com os seus números. Os ficheiros são apenas lidos e não são guardados.
Exercício E5.2: O que não é transferido? Abra o seu ficheiro ics num editor de texto. Procure um compromisso recorrente, um compromisso com participantes e um compromisso com uma ligação de videoconferência. Anote, para cada compromisso, o que precisa de fazer depois da mudança.
Exercício E5.2: O que não é transferido?
Abra o seu próprio ficheiro ics num editor de texto.
As suas marcações e notas ficam apenas neste navegador; não as enviamos para lado nenhum. Se tiver sessão iniciada, guardamos em Os meus cursos apenas que concluiu o exercício.
Para saber mais
Os passos descritos nestes artigos aplicam-se aos serviços do WebOké; noutros fornecedores, o funcionamento é semelhante.
- Manual do Nextcloud 13.5: Transferir calendário e contactos a partir do Google, iCloud ou Outlook (ics e vCard)
- Manual do Nextcloud 13.2: Google Drive, Fotos, Calendário e Contactos: transferir com a WebOké Import Tool
- Manual do Nextcloud 13.4: Transferir o OneDrive com Migração de Dados
- Manual do Nextcloud 13.6: Do Microsoft 365 para o WebOké: ficheiros, documentos, correio e calendário
- RFC 5545 (iCalendar), RFC 2426 (vCard 3.0), RFC 6350 (vCard 4.0)
- Ajuda do Google Agenda: Exportar eventos; Ajuda do Google Contactos: Exportar contactos; Suporte da Microsoft: Exportar contactos do Outlook
